"""
    ComputeTaskABC_S1 <: AbstractTaskFunction

S task with a single child.
"""
struct ComputeTaskABC_S1 <: AbstractTaskFunction end

"""
    ComputeTaskABC_S2 <: AbstractTaskFunction

S task with two children.
"""
struct ComputeTaskABC_S2 <: AbstractTaskFunction end

"""
    ComputeTaskABC_P <: AbstractTaskFunction

P task with no children.
"""
struct ComputeTaskABC_P <: AbstractTaskFunction end

"""
    ComputeTaskABC_V <: AbstractTaskFunction

v task with two children.
"""
struct ComputeTaskABC_V <: AbstractTaskFunction end

"""
    ComputeTaskABC_U <: AbstractTaskFunction

u task with a single child.
"""
struct ComputeTaskABC_U <: AbstractTaskFunction end

"""
    ComputeTaskABC_Sum <: AbstractTaskFunction

Task that sums all its inputs, n children.
"""
mutable struct ComputeTaskABC_Sum <: AbstractTaskFunction
    children_number::Int
end

"""
    ABC_TASKS

Constant vector of all tasks of the ABC-Model.
"""
ABC_TASKS =
    [ComputeTaskABC_S1, ComputeTaskABC_S2, ComputeTaskABC_P, ComputeTaskABC_V, ComputeTaskABC_U, ComputeTaskABC_Sum]
