"""
    ComputeTaskQED_S1 <: AbstractTaskFunction

S task with a single child.
"""
struct ComputeTaskQED_S1 <: AbstractTaskFunction end

"""
    ComputeTaskQED_S2 <: AbstractTaskFunction

S task with two children.
"""
struct ComputeTaskQED_S2 <: AbstractTaskFunction end

"""
    ComputeTaskQED_P <: AbstractTaskFunction

P task with no children.
"""
struct ComputeTaskQED_P <: AbstractTaskFunction end

"""
    ComputeTaskQED_V <: AbstractTaskFunction

v task with two children.
"""
struct ComputeTaskQED_V <: AbstractTaskFunction end

"""
    ComputeTaskQED_U <: AbstractTaskFunction

u task with a single child.
"""
struct ComputeTaskQED_U <: AbstractTaskFunction end

"""
    ComputeTaskQED_Sum <: AbstractTaskFunction

Task that sums all its inputs, n children.
"""
mutable struct ComputeTaskQED_Sum <: AbstractTaskFunction
    children_number::Int
end

"""
    QED_TASKS

Constant vector of all tasks of the QED-Model.
"""
QED_TASKS =
    [ComputeTaskQED_S1, ComputeTaskQED_S2, ComputeTaskQED_P, ComputeTaskQED_V, ComputeTaskQED_U, ComputeTaskQED_Sum]
